#ifndef _CMDS_H_
#define _CMDS_H_

#define Firmware			  1u // 3 seconds afterward the device will reset go into a special boot-up mode where the firmware can be reprogrammed
#define PORDevice			  2u // Resets device in 3 seconds
#define ReadDisplay			  3u // Returns 1 byte, with the 3 LSB being the current display, cursor and blink
#define ReadDisplayMin		  4u // Returns 1 byte, the current remaining time till display off, or 0
#define ReadContrast		  5u // Returns 1 byte, the current contrast level
#define ReadBacklight		  6u // Returns 1 byte, the current backlight level
#define ReadCustom			  7u // [char:0-7] Returns 8 bytes, the 8 bytes of the current char
#define ReadMessage			  8u // Returns 160 bytes, the current message
#define ReadGPO				  9u // [1-5] Returns 1 byte, the current state of the GPO
#define ReadGPOpwm			 10u // [1-5] Returns 1 byte, the current pwm of the GPO
#define ReadSavedDisplay	 13u // Returns 1 byte, with the 3 LSB being the saved display, cursor and blink
#define ReadSavedDisplayMin	 14u // Returns 1 byte, the saved time till display off, or 0
#define ReadSavedContrast	 15u // Returns 1 byte, the saved contrast level
#define ReadSavedBacklight	 16u // Returns 1 byte, the saved backlight level
#define ReadSavedCustom		 17u // [char:0-7] Returns 8 bytes, the 8 bytes of the saved char
#define ReadSavedMessage	 18u // Returns 160 bytes, the saved startup message
#define ReadSavedGPO		 19u // [1-5] Returns 1 byte, the current state of the GPO
#define ReadSavedGPOpwm		 20u // [1-5] Returns 1 byte, the current pwm of the GPO

#define SetLargeDisplay		 21u // [0-1] 1 for a display that is large (>80 characters); this setting is always remembered
#define IsLargeDisplay		 22u // Return 1 byte, 1 for large display, 0 otherwise

#define SetSerialNum		 52u // [2 bytes], can be called any number of times
#define ReadSerialNum		 53u // Returns 2 bytes
#define ReadVersion			 54u // Returns 1 byte, the version of the firmware (major version in high nibble, minor version in low nibble)
#define ReadModuleType		 55u // Returns 1 byte, exactly 0x5B to identify this software
#define SaveStartup			 64u // [160 chars] (spec says 40, but we want to be able to use 40x4)
#define DisplayOn			 66u // [mins:0-255]
#define DisplayOff			 70u
#define Position			 71u // [col:1-20][row:1-4]
#define Home				 72u
#define CursorOn			 74u
#define CursorOff			 75u
#define CursorLeft			 76u
#define CursorRight			 77u
#define DefineCustom		 78u // [char:0-7][8 bytes]
#define Contrast			 80u // [0-255]
#define BlinkOn				 83u
#define BlinkOff			 84u
#define GPOoff				 86u // [1-5]
#define GPOon				 87u // [1-5]
#define ClearDisplay		 88u
#define Backlight_			 89u // [0-255], duplicate of 152
#define GPOpwm				102u // [1-5][0-255]
#define SaveBacklight		145u // [0-255]
#define Remember			147u // [0-1]
#define Backlight			152u // [0-255]
#define GPOpwm_				192u // [1-5][0-255], duplicate of 102
#define ReadButton			193u // [1-5], returns one character A-E (this is originally for reading fan RPM)
#define RememberCustom		194u // [char:0-7][8 bytes]
#define RememberGPOpwm		195u // [1-5][0-255]
#define RememberGPO			196u // [1-5][0-1]
#define Char254				254u

#endif
